library ieee;
use ieee.std_logic_1164.all;

entity bench is
end entity bench;

architecture RTL of bench is
	signal a, b, cin, s, cout : std_logic;
	signal s2, cout2          : std_logic;
	signal correct            : boolean;
begin
	dut : entity work.adder
		port map(a => a, b => b, cin => cin, s => s, cout => cout);

	stim : process is
		type quint is array (natural range 0 to 4) of std_logic;
	begin
		(a, b, cin, s2, cout2) <= quint'('0', '0', '0', '0', '0'); wait for 10 ns;
		(a, b, cin, s2, cout2) <= quint'('1', '0', '0', '1', '0'); wait for 10 ns;
		(a, b, cin, s2, cout2) <= quint'('0', '1', '0', '1', '0'); wait for 10 ns;
		(a, b, cin, s2, cout2) <= quint'('1', '1', '0', '0', '1'); wait for 10 ns;
		(a, b, cin, s2, cout2) <= quint'('0', '0', '1', '1', '0'); wait for 10 ns;
		(a, b, cin, s2, cout2) <= quint'('1', '0', '1', '0', '1'); wait for 10 ns;
		(a, b, cin, s2, cout2) <= quint'('0', '1', '1', '0', '1'); wait for 10 ns;
		(a, b, cin, s2, cout2) <= quint'('1', '1', '1', '1', '1'); wait for 10 ns;
		wait;
	end process stim;

	correct <= (s = s2) and (cout = cout2);

end architecture RTL;
